/*
 * Backend JS for conversionPlus
 *
 */

// Radio menu
var appearanceRadio = document.getElementById('ctrl_appearance');
var fieldScrollOffset = document.getElementById('pal_appearance_legend').querySelector(".widget.scrollOffset");

function checkScrollOffsetField() {
	var appearanceRadioChecked = appearanceRadio.querySelector("input:checked").value;
	if (appearanceRadioChecked == 'onScroll') {
		fieldScrollOffset.classList.add('show');
	} else {
		fieldScrollOffset.classList.remove('show');
	}
}

checkScrollOffsetField();
appearanceRadio.addEventListener('change', function() {
    checkScrollOffsetField();
});

// Animation preview
var animationLegend = document.getElementById('pal_animation_legend');
var animationInSelect = document.getElementById('ctrl_animationIn');
var animationInSpeed = document.getElementById('ctrl_animationInSpeed');
//var animationInWidget = animationInSpeed.parentNode;
var animationOutSelect = document.getElementById('ctrl_animationOut');
var animationOutSpeed = document.getElementById('ctrl_animationOutSpeed');
//var animationOutWidget = animationOutSpeed.parentNode;


// Append preview boxes
var previewDivIn = document.createElement("div");
previewDivIn.className = "preview in";
var t = document.createTextNode("Preview");   
previewDivIn.appendChild(t);

var previewDivOut = document.createElement("div");
previewDivOut.className = "preview out";
var t = document.createTextNode("Preview");   
previewDivOut.appendChild(t);

var previewContainer = document.createElement("div");
previewContainer.className = "preview-container";

previewContainer.appendChild(previewDivIn);
previewContainer.appendChild(previewDivOut);
animationLegend.appendChild(previewContainer);

//animationInWidget.className = 'widget w50 auto-height';
//animationOutWidget.className = 'widget w50 auto-height';


// On Change
var timerAnimIn;
function removePreviewInClass(speed) {
    timerAnimIn = window.setTimeout( 
    function() {
        previewDivIn.className = "preview in";
    }, speed);
}
animationInSelect.onchange = function(){
	previewDivIn.className = "preview in animated " + this.value;
	previewDivIn.style.animationDuration = animationInSpeed.value+"ms";
	clearTimeout(timerAnimIn);
	removePreviewInClass(animationInSpeed.value);
}

var timerAnimOut;
function removePreviewOutClass(speed) {
    timerAnimOut = window.setTimeout( 
    function() {
        previewDivOut.className = "preview out";
    }, speed);
}
animationOutSelect.onchange = function(){
	previewDivOut.className = "preview out animated " + this.value;
	previewDivOut.style.animationDuration = animationOutSpeed.value+"ms";
	clearTimeout(timerAnimOut);
	removePreviewOutClass(animationOutSpeed.value);
}

// on click replay animation
previewDivIn.onclick = function() {
	previewDivIn.className = "preview in animated " + animationInSelect.value;
	previewDivIn.style.animationDuration = animationInSpeed.value+"ms";
	clearTimeout(timerAnimIn);
	removePreviewInClass(animationInSpeed.value);
}
previewDivOut.onclick = function() {
	previewDivOut.className = "preview out animated " + animationOutSelect.value;
	previewDivOut.style.animationDuration = animationOutSpeed.value+"ms";
	clearTimeout(timerAnimOut);
	removePreviewOutClass(animationOutSpeed.value);
}


// Validate Numbers on inputs
// Allow only numbers OR enter key
var validateNumbersInput = document.querySelectorAll(".validateNumbers input");
for (var i = 0; i < validateNumbersInput.length; i++) {
    (function( i ) {        	
        validateNumbersInput[i].setAttribute("onkeypress", "return event.charCode >= 48 && event.charCode <= 57 || event.charCode == 13");
    })( i );
}
